local E, L, V, P, G, _ = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB, Localize Underscore
local DT = E:GetModule('DataTexts');

local menuFrame = CreateFrame("Frame", "MaUIProf", E.UIParent)
menuFrame:SetTemplate("Transparent", true)

local mPlugin = "mMediaTag"
local displayString = ""
local mText = L["Professions"]

local mColor2 = "|CFFF7DC6F" -- yellow
local mColor5 = "|CFFE74C3C" -- red
local mColor6 = "|CFF58D68D" -- green
local mColor7 = "|CFF3498DB" -- blue

local prof1, prof2, archaeology, fishing, cooking, firstAid = nil
local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = nil
local mI = 0
local menuList = {}

local function getProf(index)
	local mskillModifier = 0
	
	name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(index)
	
	if skillModifier ~= 0 then mskillModifier = " +" .. skillModifier else mskillModifier = "" end
	
	if E.db[mPlugin].mProfIcon then
		if (skillLevel == maxSkillLevel) then
			return format ("|T"..icon..":0|t  " .. name .. " (" .. mColor6 .. '' .. skillLevel .. "|r" .. mColor6 .. mskillModifier .. "|r)")
		else
			return format ("|T"..icon..":0|t  " .. name .. " (" .. mColor2 .. '' .. skillLevel .. "|r" .. mColor6 .. mskillModifier .. "/" .. mColor7 .. '' .. maxSkillLevel .. "|r)")
		end
	else
		if (skillLevel == maxSkillLevel) then
			return format (name .. " (" .. mColor6 .. '' .. skillLevel .. "|r" .. mColor6 .. mskillModifier .. "|r)")
		else
			return format (name .. " (" .. mColor2 .. '' .. skillLevel .. "|r" .. mColor6 .. mskillModifier .. "/" .. mColor7 .. '' .. maxSkillLevel .. "|r)")
		end
	end
 end
 
local function castProf(index)
	name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(index)
		
	if name == GetSpellInfo(2575) then
		name = GetSpellInfo(2656)
	end
	
	CastSpellByName(name, self)
end

local function setupProf()
	prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions()
	mI = 1
	menuList = {}
	
	if (prof1 == nil) and (prof2 == nil) then
		tinsert(menuList, mI, {text = mColor5 .. L["No Main Professions"], isTitle = true, func = function() end})
		mI = mI + 1
	else
		tinsert(menuList, mI, {text = mColor2 .. L["Main Professions"], isTitle = true, func = function() end})
		mI = mI + 1
		
		if prof1 ~= nil then
			tinsert(menuList, mI, {text = getProf(prof1), isTitle = false, func = function() castProf(prof1) end})
			mI = mI + 1
		end
	
		if prof2 ~= nil then
			tinsert(menuList, mI, {text = getProf(prof2), isTitle = false, func = function() castProf(prof2) end})
			mI = mI + 1
		end
	end
	
	tinsert(menuList, mI, {text = "", isTitle = true, func = function() end})
		mI = mI + 1
	
	if  (archaeology == nil) and (cooking == nil) and (firstAid == nil) and (fishing == nil)  then
		tinsert(menuList, mI, {text = mColor5 .. L["No Secondary Professions"], isTitle = true, func = function() end})
		mI = mI + 1
	else
		tinsert(menuList, mI, {text = mColor2 .. L["Secondary Professions"], isTitle = true, func = function() end})
		mI = mI + 1
		
		if archaeology ~= nil then
			tinsert(menuList, mI, {text = getProf(archaeology), isTitle = false, func = function() castProf(archaeology) end})
			mI = mI + 1
		end
		
		if cooking ~= nil then
			tinsert(menuList, mI, {text = getProf(cooking), isTitle = false, func = function() castProf(cooking) end})
			mI = mI + 1
		end
		
		if firstAid ~= nil then
			tinsert(menuList, mI, {text = getProf(firstAid), isTitle = false, func = function() castProf(firstAid) end})
			mI = mI + 1
		end
		
		if fishing ~= nil then
			tinsert(menuList, mI, {text = getProf(fishing), isTitle = false, func = function() end})
			mI = mI + 1
		end
	end
end

local function OnClick(self)
	setupProf()
	mDropDown(menuList, menuFrame, E.db[mPlugin].mProfUp, 200)
end
	
local function OnEnter(self)
	DT:SetupTooltip(self)
	DT.tooltip:AddLine(mText)
	DT.tooltip:Show()
end

local function OnEvent(self, event, unit)
	self.text:SetFormattedText(displayString, mText)
end

local function OnLeave(self)
	DT.tooltip:Hide()
end

local function ValueColorUpdate(hex)
	displayString = strjoin("", hex, "%s|r")

	if lastPanel ~= nil then
		OnEvent(lastPanel, 'ELVUI_COLOR_UPDATE')
	end
end
E.valueColorUpdateFuncs[ValueColorUpdate] = true

DT:RegisterDatatext('Professions', nil, OnEvent, nil, OnClick, OnEnter, OnLeave, mText)